package de.ozgcloud.eingang.xta;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mapstruct.factory.Mappers;
import org.mockito.Spy;

class XtaMessageMetaDataMapperTest {

	@Spy
	private final XtaMessageMetaDataMapper mapper = Mappers.getMapper(XtaMessageMetaDataMapper.class);

	@DisplayName("msg status list from soap")
	@Nested
	class TestMsgStatusListFromSoap {

		@Test
		void shouldMap() {
			var response = MsgStatusListTypeAndHeaderResponseTestFactory.create();

			var result = mapper.msgStatusListFromSoap(response);

			assertThat(result).isNotNull();
		}

		@DisplayName("should set moreMessagesAvailable to false")
		@Test
		void shouldSetMoreMessagesAvailableToFalse() {
			var response = MsgStatusListTypeAndHeaderResponseTestFactory.create();

			var result = mapper.msgStatusListFromSoap(response);

			assertThat(result.isMoreMessagesAvailable()).isFalse();
		}
	}
}
