package de.ozgcloud.eingang.xta;

import static de.ozgcloud.eingang.xta.XtaMessageTestFactory.*;

import java.time.ZonedDateTime;

import de.ozgcloud.eingang.common.formdata.FormMetaDataTestFactory;

class XtaMessageMetaDataTestFactory {

	static final String MESSAGE_TYPE = "Geschaeftsgang.Geschaeftsgang.0201";
	static final String FIM_MESSAGE_TYPE = "fim.S17000652.17000652001004";
	static final ZonedDateTime ORIGIN = ZonedDateTime.parse("2022-10-29T15:45:52.4942149+02:00");
	static final String SERVICE = "urn:fim:Versammlungsanzeige:1.4";
	static final String MESSAGE_TYPE_LIST_VERSION = "1.0";

	static XtaMessageMetaData create() {
		return createBuilder().build();
	}

	static XtaMessageMetaData.XtaMessageMetaDataBuilder createBuilder() {
		return XtaMessageMetaData.builder()
				.messageId(MESSAGE_ID)
				.messageType(MESSAGE_TYPE)
				.messageTypeListVersion(MESSAGE_TYPE_LIST_VERSION)
				.origin(ORIGIN)
				.xtaIdentifier(FormMetaDataTestFactory.XTA_IDENTIFIER)
				.service(SERVICE);
	}

	static XtaMessageMetaData createFim() {
		return createFimBuilder().build();
	}

	static XtaMessageMetaData.XtaMessageMetaDataBuilder createFimBuilder() {
		return createBuilder()
				.messageType(FIM_MESSAGE_TYPE);
	}
}
